#!/bin/python

import tensorflow as tf
import numpy as np

def model_variable(shape, name):
        variable = tf.get_variable(name=name,
                                   dtype=tf.float32,
                                   shape=shape,
                                   initializer=tf.random_normal_initializer(stddev=0.1)
        )
        tf.add_to_collection('model_variables', variable)
        tf.add_to_collection('l2', tf.reduce_sum(tf.pow(variable,2)))
        return variable

def linear_model(input_):
    w = model_variable([], 'w')
    b = model_variable([], 'b')
    return w*input_ + b

x_ = tf.placeholder(tf.float32, shape=[])
y_ = tf.placeholder(tf.float32, shape=[])
yhat = linear_model(x_)
model_variables = tf.get_collection('model_variables')

mse = tf.reduce_mean(tf.pow(yhat - y_, 2))
l2_penalty = tf.reduce_sum(tf.get_collection('l2'))
loss = mse + 1e-3*l2_penalty

optim = tf.train.GradientDescentOptimizer(learning_rate=0.1).minimize(loss, var_list=model_variables)

def data():
    num_samp = 50
    sigma = 0.1
    w = 5
    b = 2
    np.random.seed(31415)
    for _ in range(num_samp):
        x = np.random.uniform()
        y = w*x + b + np.random.normal()*sigma
        yield x, y

sess = tf.Session()
sess.run(tf.initialize_all_variables())

for _ in range(10):
    for example, target in data():
        l, _ = sess.run([loss, optim], feed_dict={x_ : example , y_ : target})
        print(l)        
    
print(sess.run(tf.get_collection('model_variables')))
